#774 closed enhancement (fixed)

avoid silent FP reg. corruption by user ISR

Reported by: strauman Owned by: Joel Sherrill
Priority: highest Milestone: 2
Component: bsps Version: 4.6
Severity: minor Keywords:
Cc: bugs@…, strauman@… Blocked By:
Blocking:

Description

Exception processing enabled MSR_FP (FPU) prior to calling user ISR but doesn't save FPU state --> if user ISR clobbers FP registers corruption results (can happen inadvertently if the compiler/optimizer decides to use FPregs!!)

This patch makes sure the FPU is off across the user ISR hence the user is warned because a bad ISR raises an exception.

NOTE: other BSPs might be affected [only shared, eth_comm, mbx8xx, mpc8260ads are fixed] as a result of the poor 'copy/paste' design of the new exception processing...

Release:
4.6.2

Environment:
PPC BSPs with 'new' exception processing

Attachments (1)

ppcbsp-fpoff-across-isr.diff (8.2 KB) - added by strauman on Dec 3, 2006 at 1:31:12 PM.
ppcbsp-fpoff-across-isr.diff

Download all attachments as: .zip

Change History (5)

comment:1 Changed on May 20, 2005 at 6:37:17 PM by Joel Sherrill

Status: assignedwaiting

comment:2 Changed on May 23, 2005 at 11:54:25 PM by strauman

Status: waitingassigned

comment:3 Changed on Oct 19, 2005 at 6:37:40 PM by strauman

Status: assignedwaiting

comment:4 Changed on Nov 8, 2005 at 2:19:24 AM by strauman

Status: waitingclosed

State-Changed-From-To: feedback->closed
State-Changed-Why: Verified that the patch has been applied to head and 4.6 branch

Changed on Dec 3, 2006 at 1:31:12 PM by strauman

ppcbsp-fpoff-across-isr.diff

Note: See TracTickets for help on using tickets.